#include <stdint.h>
#include "mqtttopicmatcher.h"


int cmpTopicWithWildcard(char *subscribedTopic, char *receivedTopic) {
    uint32_t s_idx = 0;
    uint32_t r_idx = 0;
    char s;
    char r;

    enum { e_START, e_PART, e_DELIMITER, e_WAIT_FOR_DELIMITER_IN_S, e_WAIT_FOR_DELIMITER_IN_R, e_OK, e_NOK } state;
    state = e_START;

    while (1) {
        s = *(subscribedTopic + s_idx);
        r = *(receivedTopic + r_idx);

        if ((s == 0) && (r == 0) && (state == e_PART)) {
            return 0;
        }

        switch (state) {
        case e_START:            
            if (s == '#') {
                state = e_OK;
                break;
            } else if (s == '+') {
                state = e_WAIT_FOR_DELIMITER_IN_S;
                s_idx++;
                r_idx++;
                break;
            } else if (s == '/') {
                state = e_DELIMITER;
                s_idx++;
                r_idx++;
                break;
            } else if (s == r) {
                state = e_PART;
                s_idx++;
                r_idx++;
                break;
            } else {
                state = e_NOK;
                break;
            }
        case e_DELIMITER:
            if (s == '#') {
                state = e_OK;
                break;
            } else if (s == '+') {
                state = e_WAIT_FOR_DELIMITER_IN_S;
                s_idx++;
                r_idx++;
                break;
            } else if (s == r) {
                state = e_PART;
                s_idx++;
                r_idx++;
                break;
            } else {
                state = e_NOK;
                break;
            }
        case e_WAIT_FOR_DELIMITER_IN_S:
            if (s != '/') {
                state = e_NOK;
                break;
            } else if ((s == '/') && (r == '/')) {
                state = e_PART;
                s_idx++;
                r_idx++;
                break;
            } else if ((s == '/') && (r != '/')) {
                state = e_WAIT_FOR_DELIMITER_IN_R;
                r_idx++;
                break;
            } else {
                state = e_NOK;
                break;
            }
        case e_WAIT_FOR_DELIMITER_IN_R:
            if (r == '/') {
                state = e_PART;
                s_idx++;
                r_idx++;
                break;
            } else {
                r_idx++;
                break;
            }
        case e_PART:
            if (s == '#') {
                state = e_OK;
                break;
            } else if (s == '+') {
                state = e_WAIT_FOR_DELIMITER_IN_S;
                s_idx++;
                r_idx++;
                break;
            } else if (s == r) {
                state = e_PART;
                s_idx++;
                r_idx++;
                break;
            } else {
                state = e_NOK;
                break;
            }
        }

        if (state == e_OK) {
            return 0;
        } else if (state == e_NOK) {
            return -1;
        }
    }
}
